**Pyekfmm**
======

## Description

**Pyekfmm** is python package for 3D fast-marching-based traveltime calculation and its applications in seismology. The initial version of this package was held at https://github.com/chenyk1990/pyekfmm, which is no longer maintained.


## Reference
    Chen et al. (2023). A python package for 3D fast-marching-based traveltime calculation and its applications in seismology, in preparation
    
BibTeX:

	@article{pyekfmm,
	  title={Pyekfmm: A python package for 3D fast-marching-based traveltime calculation and its applications in seismology},
	  author={Chen et al.},
	  journal={TBD},
	  volume={TBD},
	  number={TBD},
	  issue={TBD},
	  pages={in preparation},
	  year={2023}
 	}

-----------
## Copyright
    pyekfmm developing team, 2021-present
-----------

## License
    GNU General Public License, Version 3
    (http://www.gnu.org/copyleft/gpl.html)   

-----------

## Install
Using the latest version

    git clone https://github.com/aaspip/pyekfmm
    cd pyekfmm
    pip install -v -e .
or using Pypi

    pip install pyekfmm

-----------
## Examples
    The "demo" directory contains all runable scripts to demonstrate different applications of pyekfmm. 

-----------
## Dependence Packages
* scipy 
* numpy 
* matplotlib

-----------
## Development
    The development team welcomes voluntary contributions from any open-source enthusiast. 
    If you want to make contribution to this project, feel free to contact the development team. 

-----------
## Contact
    Regarding any questions, bugs, developments, collaborations, please contact  
    Yangkang Chen
    chenyk2016@gmail.com

-----------
## Gallery
The gallery figures of the pyekfmm package can be found at
    https://github.com/aaspip/gallery/tree/main/pyekfmm
Each figure in the gallery directory corresponds to a DEMO script in the "demo" directory with the exactly the same file name.

These gallery figures are also presented below. 

DEMO1 (test_1_constv.m)

<img src='https://github.com/chenyk1990/gallery/blob/main/pyekfmm/test_1_constv.png' alt='DEMO1' width=960/>

DEMO 12 (traveltime calculation for VTI media) 
<img src='https://github.com/chenyk1990/gallery/blob/main/pyekfmm/test_12_constvti.png' alt='DEMO1' width=960/>

DEMO 13 (traveltime calculation in 3D) 
<img src='https://github.com/chenyk1990/gallery/blob/main/pyekfmm/test_13_plot3d_new.png' alt='DEMO1' width=960/>

DEMO (Ray tracing in 3D) 
<img src='https://github.com/chenyk1990/gallery/blob/main/pyekfmm/test_1_vgrad_ray.png' alt='DEMO1' width=960/>

DEMO (Ray tracing in 2D Surface wave tomography) 
<img src='https://github.com/chenyk1990/gallery/blob/main/pyekfmm/test_15_inputv2d.png' alt='DEMO1' width=960/>

DEMO (Ray tracing in 2D Surface wave tomography) Generated by [test_16_tomo_rays_spherical.py](https://github.com/chenyk1990/pyekfmm/tree/main/demos/test_16_tomo_rays_spherical.py)
<img src='https://github.com/chenyk1990/gallery/blob/main/pyekfmm/test_16_tomo_rays2.png' alt='DEMO1' width=960/>

